/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2006-2012 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2006-2012 Toporov Konstantin.
 */

package org.diacalc.mobile.components;

import com.sun.lwuit.Command;
import com.sun.lwuit.VirtualKeyboard;
import java.util.Vector;

/**
 * @author Toporov Konstantin <www.diacalc.org> 
 */
public class NumbersKeyboard extends VirtualKeyboard{
    public static String[][] NUMBERS_KEYS = new String[][]
                {{"1", "2", "3","+","-"},
                {"4", "5", "6", "*", "/"},
                {"7", "8", "9","(",")"},
                {"0",".","$Delete$","$OK$"}};
    public NumbersKeyboard(){
        super();
        addInputMode("1+2", NUMBERS_KEYS );
        setInputModeOrder(new String[]{"1+2"});
    }
    
    
    private Vector closeListeners = new Vector();
    public void addCloseListener(CloseListener cl){
        closeListeners.addElement(cl);
    }
    public void removeCloseListener(CloseListener cl){
        closeListeners.removeElement(cl);
    }
    private void fireCloseEvent(){
        for(int i=0;i<closeListeners.size();i++){
            ((CloseListener)closeListeners.elementAt(i)).wasClosed();
        }
    }

    private boolean flagExit = true;
    public void setInputType(int inputType) {} //bug fix
    public void dispose(){//Любое закрытие клавиатуры сымитирует нажатие Ок
        if (flagExit){
            flagExit = false;
            this.actionCommand(new Command("Ok",VirtualKeyboard.OK));
            flagExit = true;
        }else{
            super.dispose();
            fireCloseEvent();
        }
    }
}
