/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * Copyright 2009 Toporov Konstantin. All rights reserved.
 *
 * The contents of this file are subject to the terms of either the GNU
 * General Public License Version 3 only ("GPL")  (collectively, the
 * "License"). You may not use this file except in compliance with the
 * License. You can obtain a copy of the License at
 * http://www.gnu.org/copyleft/gpl.html  See the License for the
 * specific language governing permissions and limitations under the
 * License.  When distributing the software, include this License Header
 * You should include file containing license in each project.
 * If applicable, add the following below the
 * License Header, with the fields enclosed by brackets [] replaced by
 * your own identifying information:
 * "Portions Copyrighted [year] [name of copyright owner]"
 *
 * If you wish your version of this file to be governed by
 * the GPL Version 3, indicate your decision by adding
 * "[Contributor] elects to include this software in this distribution
 * under the [GPL Version 3] license." If you do not indicate a
 * single choice of license, a recipient has the option to distribute
 * your version of this file under the GPL Version 3 or
 * to extend the choice of license to its licensees as provided above.
 * However, if you add GPL Version 3 code and therefore, elected the GPL
 * Version 3 license, then the option applies only if the new code is
 * made subject to such option by the copyright holder.
 *
 * Contributor(s):
 *
 * Portions Copyrighted 2010 Toporov Konstantin.
 */

package org.diacalc.mobile.maths;

/**
 *
 * @author Toporov Konstantin <www.diacalc.org>
 */
import com.sun.lwuit.Component;
import com.sun.lwuit.Container;
import com.sun.lwuit.Label;
import com.sun.lwuit.TextField;
import com.sun.lwuit.geom.Dimension;
import com.sun.lwuit.layouts.BorderLayout;
import java.util.Vector;


public class Str {
    public static  Vector split(String st,String div){
        Vector res = new Vector();
        int start = 0;
        int pos = 0;
        while(pos<st.length()){
            pos = st.indexOf(div, start);
            if (pos>=0){
                res.addElement(st.substring(start, pos));
                start = pos + div.length();
            }
            else break;
        }
        res.addElement(st.substring(start, st.length()));
        return res;
    }
    public static float pow(float v,int p){
        if (p<=0) return 1f;
        float res = v;
        for(int i=0;i<(p-1);i++){
            res *= v;
        }
        return res;
    }
    public static float round(float v,int z){
        return (float)(int)((v+ 0.5f/pow(10f,z)  )* pow(10.0f,z)) /  pow(10.0f,z);
    }
    /*public static  int round(float v){
       return (int)(v+0.5f);
    }
    public static float round0(float v){
       return (float)(int)((v+0.05f)*10.0f)/10.0f;
    }
    public static float round00(float v){
       //round to 2 decimal points
       //double number = (double)(int)((bmi+0.005)*100.0)/100.0;
       //round to 4 decimal points
       //double number = (double)(int)((bmi+0.00005)*10000.0)/10000.0;
       return (float)(int)((v+0.005f)*100.0f)/100.0f;
    }*/
    
    
    

   private final static MathEvaluator evaluter = new MathEvaluator();

   private final static String numb = "1234567890.+-*/()";
   private final static String nodouble = ".+-*/";

   public static float parseString(TextField row,int zeros){
        String st = row.getText().trim();
        if (st.length()==0) return 0f;
        String st1="";
        //удаляем все неиспользуемые символы
        for(int i=0;i<st.length();i++){
            for(int j=0;j<numb.length();j++){
                if (st.charAt(i)==numb.charAt(j)){
                    st1 += st.charAt(i);
                    break;
                }
            }
        }
        //Двойные символы так же надо убрать
        if (st1.length()>1){
            int i=0;
            boolean found = false;
            while (i<(st1.length()-1)){
                found = false;
                if (st1.charAt(i)==st1.charAt(i+1)){
                    for(int j=0;j<nodouble.length();j++){
                        if (st1.charAt(i)==nodouble.charAt(j)){
                            //Удаляем
                            st1 = st1.substring(0, i) + st1.substring(i+1);
                            found = true;
                            break;
                        }
                    }
                }
                if (!found) i++;
            }
        }

        //считаем скобки
        int c=0;
        int a=0;
        for(int i=0;i<st1.length();i++){
            if (st1.charAt(i)=='(') c++;
            if (st1.charAt(i)==')') a++;
        }
        if (c>a){//Добавляем в конец ) скобки
            for(int i=0;i<(c-a);i++){
                st1 += ')';
            }
        }
        else if (c<a){//Добавляем в начало ( скобки
            for(int i=0;i<(a-c);i++){
                st1 = '(' + st1;
            }
        }
        float res;
        evaluter.setExpression(st1);
        try{
            res = evaluter.getValue().floatValue();
        }
        catch(Exception ex){
            res = 0f;
        }
        res = res>0?res:0f;

        String strR = ""+Str.round(res, zeros);
        int p = strR.indexOf(".");
        if (zeros==0){
            strR = strR.substring(0, p);
        }else{//проверяем достаточность знаков после запятой
            int l = strR.length()-p - 1; //0.12 - 2 = 2  0.123 -2 = 3
            //кол-во знаков после запятой
            // 1.1    // 1 до десят части длина 3 - после запят 1
            // 0.11   // 1 до десят части длина 4 - после запятой 2
            // 15.123 // 2 до десят части длина 6 - после запятой 3
            for(int i=0;i<(zeros-l);i++){
                strR += "0";
            }
        }
        row.setText(strR);
        return res;
    }
    public static String extendZero(int v){
        return v<10?("0"+v):(""+v);
    }
    public static String replace(String src,String frst,String scd){
        //Ищем вхождение first и меняем его на scd
        int i = -1;
        String res = src;
        while(  (i=res.indexOf(frst))>=0 ){
            res = res.substring(0, i) + scd + res.substring(i+frst.length());
        }
        return res;
    }
    /**
     * Helper method that allows us to create a pair of components label and the given
     * component in a horizontal layout with a minimum label width
     */
    public static Container createPair(String label, Component c, int minWidth) {
        Container pair = new Container(new BorderLayout());
        Label l =  new Label(label);
        l.getStyle().setAlignment(Label.RIGHT);
        Dimension d = l.getPreferredSize();
        d.setWidth(Math.max(d.getWidth(), minWidth));
        l.setPreferredSize(d);
        pair.addComponent(BorderLayout.WEST,l);
        pair.addComponent(BorderLayout.CENTER, c);
        return pair;
    }

      /**
     * Helper method that allows us to create a pair of components label and the given
     * component in a horizontal layout
     */
     public static Container createPair(String label, Component c) {
         return createPair(label,c,0);
     }
     public static String addZero(float v){//0.00
        String st = "" + v;
        int p = st.indexOf(".");
        if (p<0) return st;
        //[ 0 . 0 ] p = 1 l = 3 l-p=2
        //[ 10.0  ] p = 2 l= 4 l-p=2
        //[ 10.00 ] p = 2 l =5 l-p=3
        if ((st.length()-p)<3) st += "0";
        return st;
    }
}
